#ifndef _EXCHANGER_H_
#define _EXCHANGER_H_

#include "bmsfel.h"

class ListExchanger {
protected:
  BmsBms *bms;
  int before[BmsWord::MAX + 1];
  BmsWord after[BmsWord::MAX];
  int channel_type;

public:
  ListExchanger();
  ListExchanger( BmsBms *bms, int channel_type );

  void set_bms( BmsBms *bms );
  void set_channel_type( int channel_type );
  void clear_list();
  void clear_and_set( BmsBms *bms, int channel_type );
  void add_list( BmsWord before_word, BmsWord after_word );
  void do_exchange();

  int get_count();
};

#endif // _EXCHANGER_H_
